#ifndef SLEV_ALGORITHM_H_
#define SLEV_ALGORITHM_H_

#include<iostream>
#include<vector>
#include<cmath>

#include "def_the_type.h"
#include "data.h"
using namespace std;
class SLEV_algorithm {
    private:
        vector<bool> if_selected;

        the_Matrix XXT;
        the_Matrix XXT_inv;
        vector<T> XY;
        vector<T> H;
        vector<T> H_sum;
        T alpha;

        void select();
        void compute();
        vector<T> solve();
        int find_index(T);

    public:
        the_Data *data;
        SLEV_algorithm(the_Data *input_data, int n);
        ~SLEV_algorithm();
        int N, p, n;
        vector<T> Execute();
};

#endif
